classdef (SharedTestFixtures={...
    check_mds,setup_gdatpaths})...
    test_tcv_get_ids < matlab.unittest.TestCase

  properties(TestParameter)
    shot = {-1,40000,61400};
    ids_name = {'pf_active','wall'};
  end

  methods(Test,TestTags = {'imas'})
    function test_get_ids_list(testCase,shot)
      gg = testCase.assertWarning(@() gdat(shot,'ids'),'gdat:EmptyIDSName');

      testCase.assertTrue(iscell(gg.gdat_params.sources_available));
    end

    function test_tcv2ids(testCase,shot,ids_name)
      if shot==-1 && strcmp(ids_name,'pf_active')
        ids = testCase.assertWarning(@() tcv2ids(shot,'ids_name',{ids_name}),'TCV:IDS:NoTimeData');
      else
        ids = testCase.assertWarningFree(@() tcv2ids(shot,'ids_name',{ids_name}));
      end
      testCase.assertTrue(~isempty(ids))
    end
  end

end
